<template>
  <div class="room-filter">
    <div class="section-ttl">
      <h2 class="section-ttl__txt">Rooms Search</h2>
      <div class="section-ttl__line"></div>
    </div>
    <form class="room-filter-form">
      <div class="form-group">
        <label htmlFor="type">Room Type</label>
        <select
          name="type"
          id="type"
          class="form-control"
          v-model="filterObj.type"
          @change="filterRooms"
        >
          <option v-for="(type, index) in types" :key="index" :value="type">
            {{ type }}
          </option>
        </select>
      </div>
      <div class="form-group">
        <label htmlFor="capacity">Guests</label>
        <select
          name="capacity"
          id="capacity"
          class="form-control"
          v-model="filterObj.capacity"
          @change="filterRooms"
        >
          <option
            v-for="(capacity, index) in capacities"
            :key="index"
            :value="capacity"
          >
            {{ capacity }}
          </option>
        </select>
      </div>

      <div class="form-group">
        <label htmlFor="price"
          >Room Price ${{ price ? price : maxPrice }}</label
        >
        <input
          type="range"
          name="price"
          id="price"
          :max="maxPrice"
          min="0"
          v-model="filterObj.price"
          @change="filterRooms"
          class="form-control"
        />
      </div>

      <div class="form-group">
        <label htmlFor="">Room Size</label>
        <div class="size-inputs">
          <input
            type="number"
            name="minSize"
            id="minSize"
            class="size-inputs__item"
            v-model="filterObj.minSize"
            @keyup="filterRooms"
          />
          <input
            type="number"
            name="maxSize"
            id="maxSize"
            class="size-inputs__item"
            v-model="filterObj.maxSize"
            @keyup="filterRooms"
          />
        </div>
      </div>

      <div class="form-group">
        <div class="extras-input">
          <input
            type="checkbox"
            name="breakfast"
            id="breakfast"
            v-model="filterObj.breakfast"
            @change="filterRooms"
          />
          <label for="breakfast">breakfast</label>
        </div>
        <div class="extras-input">
          <input
            type="checkbox"
            name="pets"
            id="pets"
            v-model="filterObj.pets"
            @change="filterRooms"
          />
          <label for="pets">pets</label>
        </div>
      </div>
    </form>
  </div>
</template>

<script>
import filterObj from "./filterObj";
import { mapMutations, mapGetters } from "vuex";
import store from "./../../store";

export default {
  name: "RoomFilter",
  data() {
    return {
      filterObj,
    };
  },
  beforeMount() {
    this.filterObj._maxSize = 1000
  },
  methods: {
    filterRooms() {
      store.dispatch("filterRooms", this.filterObj);
    },
  },
  computed: {
    ...mapGetters({
      types: "types",
      capacities: "capacities",
      maxPrice: "maxPrice",
      price: "price",
      maxSize: "maxSize",
    }),
  },
};
</script>
<style lang="">
.room-filter {
  padding: 5rem 0;
}

.room-filter-form {
  width: 60vw;
  margin: 0 auto;
  display: grid;
  grid-template-columns: repeat(auto-fit, minmax(202px, 1fr));
  grid-row-gap: 2rem;
  grid-column-gap: 40px;
}

.form-group {
  text-transform: capitalize;
}

.form-group label {
  display: block;
  letter-spacing: var(--mainSpacing);
  margin-bottom: 0.5rem;
}

.form-control {
  width: 100%;
  background: transparent;
  font-size: 1rem;
}

.size-inputs {
  display: flex;
}

.size-inputs__item {
  width: 40%;
  padding: 0.2rem;
  border: 1px solid var(--mainBlack);
  border-radius: 0.3rem;
  margin-right: 0.3rem;
}

.extras-input label {
  display: inline-block;
  font-size: 0.8rem;
  margin-left: 0.5rem;
}

@media screen and (min-width: 992px) {
  .room-filter-form {
    width: 95vw;
    max-width: 1170px;
  }
}
</style>
